org.keycloak.storage.ldap.mappers

## Interface LDAPStorageMapperFactory<T extends LDAPStorageMapper>

- All Superinterfaces:
    ComponentFactory<T,LDAPStorageMapper>, ConfiguredProvider, ProviderFactory<LDAPStorageMapper>, SubComponentFactory<T,LDAPStorageMapper>
  All Known Implementing Classes:
    AbstractLDAPStorageMapperFactory, CertificateLDAPStorageMapperFactory, FullNameLDAPStorageMapperFactory, GroupLDAPStorageMapperFactory, HardcodedAttributeMapperFactory, HardcodedLDAPAttributeMapperFactory, HardcodedLDAPGroupStorageMapperFactory, HardcodedLDAPRoleStorageMapperFactory, MSADLDSUserAccountControlStorageMapperFactory, MSADUserAccountControlStorageMapperFactory, RoleLDAPStorageMapperFactory, UserAttributeLDAPStorageMapperFactory

      public interface LDAPStorageMapperFactory<T extends LDAPStorageMapper>
      extends SubComponentFactory<T,LDAPStorageMapper>

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default void` | `close()` This is called when the server shuts down.
    `T` | `create(KeycloakSession session, ComponentModel model)` called per Keycloak transaction.
    `default List<ProviderConfigProperty>` | `getConfigProperties()`
    `default String` | `getHelpText()`
    `String` | `getId()` This is the name of the provider and will be showed in the admin console as an option.
    `default void` | `init(Config.Scope config)` Only called once when the factory is first created.
    `default void` | `onCreate(KeycloakSession session, RealmModel realm, ComponentModel model)` Called when UserStorageProviderModel is created.
    `default void` | `onParentUpdate(RealmModel realm, UserStorageProviderModel oldParent, UserStorageProviderModel newParent, ComponentModel mapperModel)`
    `default void` | `postInit(KeycloakSessionFactory factory)` Called after all provider factories have been initialized
    `default void` | `validateConfiguration(KeycloakSession session, RealmModel realm, ComponentModel config)` Called before a component is created or updated.

    - ### Methods inherited from interface org.keycloak.component.SubComponentFactory

      `getConfigProperties, getTypeMetadata`

    - ### Methods inherited from interface org.keycloak.component.ComponentFactory

      `create, getCommonProviderConfigProperties, getTypeMetadata, onUpdate, preRemove`

    - ### Methods inherited from interface org.keycloak.provider.ProviderFactory

      `order`

- - ### Method Detail

    - #### create

          T create(KeycloakSession session,
                   ComponentModel model)

      called per Keycloak transaction.
      Specified by:
        `create` in interface `ComponentFactory<T extends LDAPStorageMapper,LDAPStorageMapper>`
      Parameters:
        `session` -
        `model` -
      Returns:

    - #### getId

          String getId()

      This is the name of the provider and will be showed in the admin console as an option.
      Specified by:
        `getId` in interface `ProviderFactory<LDAPStorageMapper>`
      Returns:

    - #### init

          default void init(Config.Scope config)

      Description copied from interface: `ProviderFactory`
      Only called once when the factory is first created. This config is pulled from keycloak_server.json
      Specified by:
        `init` in interface `ProviderFactory<LDAPStorageMapper>`

    - #### postInit

          default void postInit(KeycloakSessionFactory factory)

      Description copied from interface: `ProviderFactory`
      Called after all provider factories have been initialized
      Specified by:
        `postInit` in interface `ProviderFactory<LDAPStorageMapper>`

    - #### close

          default void close()

      Description copied from interface: `ProviderFactory`
      This is called when the server shuts down.
      Specified by:
        `close` in interface `ProviderFactory<LDAPStorageMapper>`

    - #### getHelpText

          default String getHelpText()

      Specified by:
        `getHelpText` in interface `ConfiguredProvider`

    - #### getConfigProperties

          default List<ProviderConfigProperty> getConfigProperties()

      Specified by:
        `getConfigProperties` in interface `ConfiguredProvider`

    - #### validateConfiguration

          default void validateConfiguration(KeycloakSession session,
                                             RealmModel realm,
                                             ComponentModel config)
                                      throws ComponentValidationException

      Description copied from interface: `ComponentFactory`
      Called before a component is created or updated. Allows you to validate the configuration
      Specified by:
        `validateConfiguration` in interface `ComponentFactory<T extends LDAPStorageMapper,LDAPStorageMapper>`
      Throws:
        `ComponentValidationException`

    - #### onParentUpdate

          default void onParentUpdate(RealmModel realm,
                                      UserStorageProviderModel oldParent,
                                      UserStorageProviderModel newParent,
                                      ComponentModel mapperModel)

    - #### onCreate

          default void onCreate(KeycloakSession session,
                                RealmModel realm,
                                ComponentModel model)

      Called when UserStorageProviderModel is created. This allows you to do initialization of any additional configuration you need to add. For example, you may be introspecting a database or ldap schema to automatically create mappings.
      Specified by:
        `onCreate` in interface `ComponentFactory<T extends LDAPStorageMapper,LDAPStorageMapper>`
      Parameters:
        `session` -
        `realm` -
        `model` -

Copyright © 2021 JBoss by Red Hat. All rights reserved.